var LOGFILE_NAME = "thanos.log";
var lWarn = {
	logln : function(o) {
	}
};
var lInfo = {
	logln : function(o) {
	}
};
	
lInfo = new Logger(LOGFILE_NAME);
lWarn = new Logger(LOGFILE_NAME);

function fetchAcutalValue(dsid) {
	try {
		var generalSettingArray=Property.getNode('devices/'+dsid+'/generalSettings').getChildren();
		for (var iIndex=0;iIndex<generalSettingArray.length;iIndex++) {
			var deviceIndex=generalSettingArray[iIndex].getChild("deviceIndex").getValue();
			var bank=generalSettingArray[iIndex].getChild("bank").getValue();
			var index=generalSettingArray[iIndex].getChild("index").getValue();
			var value=generalSettingArray[iIndex].getChild("value").getValue();
			if (deviceIndex==0)
				if (bank==127)
					if (index==146)
						return (value!=255);
		}
	} catch (e) {
	}
	lInfo.logln('no value known');
	return null;
}
	
function checkThanos(dsid,baseDSID) {
	
	lInfo.logln('check for ' + dsid + ' for target temperature');
	
	var fHeatingActive=true;
	if (Property.getNode('/usr/states/heating_water_system/value')!=null) {
		var stateValue=Property.getProperty('/usr/states/heating_water_system/value');
		if (stateValue!=1) {
			fHeatingActive=false;
			lInfo.logln('heating systems tells that no warm water is avaible -> now I assume, that the heating will not heat');
		}
	}
	
	var activeZone=Property.getProperty('/apartment/zones/zone0/devices/' + dsid + '/ZoneID');
	var zZone = getZoneByID(activeZone);
	var config=zZone.getTemperatureControlConfiguration();
	if (config.ControlMode != 1) {
		fHeatingActive=false;
		lInfo.logln('heating systems tells that zone controller is not pid controlled -> now I assume that there is no heating');
	}
	var fSkip=false;
	var fActualValue=fetchAcutalValue(baseDSID);
	if (fActualValue!=null)
		if (fActualValue==fHeatingActive)
			fSkip=true;
	if (!fSkip) {
		if (fHeatingActive) {
			lInfo.logln('set value heating');
			new Event('thanos.config',{
				actions:'setDeviceParameter',
				dsid:baseDSID,
				insertSettings:true,
				values:escape('[' + //{"bank":127,"index":50,"deviceIndex":0,"bitmask":64,"value":'+fHeatingActive+'},'+
						'{"bank":127,"index":146,"deviceIndex":1,"value":247},' +
						'{"bank":127,"index":149,"deviceIndex":1,"value":248},' +
						'{"bank":127,"index":151,"deviceIndex":1,"value":152},' +
						'{"bank":127,"index":153,"deviceIndex":1,"value":153}]')
			}).raise();
		} else {
			lInfo.logln('set value cooling');
			new Event('thanos.config',{
				actions:'setDeviceParameter',
				dsid:baseDSID,
				insertSettings:true,
				values:escape('[' + //{"bank":127,"index":50,"deviceIndex":0,"bitmask":64,"value":'+fHeatingActive+'},'+
						'{"bank":127,"index":146,"deviceIndex":1,"value":255},' +
						'{"bank":127,"index":149,"deviceIndex":1,"value":255},' +
						'{"bank":127,"index":151,"deviceIndex":1,"value":255},' +
						'{"bank":127,"index":153,"deviceIndex":1,"value":255}]')
			}).raise();
			
		}
	} 
	else {
		lInfo.logln('guessing value is right, skip!');
	}
}

function checkAllThanos() {
	if (Property.getNode('devices')==null) {
		lInfo.logln('devices not readout yet');
		return;
	}
	var baseDevices=Property.getNode('devices').getChildren();
	for (var iIndex=0;iIndex<baseDevices.length;iIndex++) {
		checkThanos(baseDevices[iIndex].getChild('1/dSID').getValue(),baseDevices[iIndex].getChild('id').getValue());	
	}

}

lInfo.logln('---- start sync to heating system  ----- ' + raisedEvent.name);
checkAllThanos();
lInfo.logln('---- end sync to heating system  ----- ');
