Ext.define('DSS.wizard.ScreenAssitentSelector', {
	extend : 'DSS.component.Base',
	mixins : {
		observable : 'Ext.util.Observable'
	},
	getHeight : function() {
		return 240;
	},
	height : '100%',
	lblSelected:null,
	groupZoneSetting:null,
	otherSettings:null,
	groupCheckBox:[],
	otherCheckBox:[],
	baseDSID:null,
	constructor : function(config) {		
		var me=this;

		this.groupZoneSetting=Ext.create('Ext.form.FieldSet',{
            title : _('New room settings'),
            items : [],
            padding: "5 5 10 10",
            margin: 5,
            width:275
		});
		this.otherSettings=Ext.create('Ext.form.FieldSet', {
            title : _('Other settings maintain'),
            items : [],
            padding: "5 5 10 10",
            margin: 5,
            width:275

		});
		Ext.apply(this, {
			items : [ this.groupZoneSetting,this.otherSettings],
			height: "100%",
			width:590,
			layout: {
				type: 'table',
				columns: 2,
				tdAttrs:{
					style:'vertical-align: top;'
				}
			}
		});
		
		this.callParent(arguments);
	},
	reset : function() {
	},
	isValid : function() {
		return true;
	},
	newZone:null,
	setValue : function(oValue,allValues) {
		this.newZone=allValues.baseValues.zone;
		this.groupCheckBox=[];
		this.groupZoneSetting.removeAll();
		this.otherCheckBox=[];
		this.otherSettings.removeAll();
		
		var oArray=dss.staticDataModel.getGroupForZone(this.newZone);

		
		
		var checkbox=Ext.create('Ext.form.field.Checkbox',{
			boxLabel:dss.staticDataModel.getNameForGroup(this.newZone,1),
			checked:true,
			disabled:true
		});
		checkbox.groupValue=1;
		this.groupCheckBox.push(checkbox);
		this.groupZoneSetting.add(checkbox);
		
		checkbox=Ext.create('Ext.form.field.Checkbox',{
			boxLabel:dss.staticDataModel.getNameForGroup(this.newZone,48),
			checked:true,
			disabled:true
		});
		checkbox.groupValue=48;
		this.groupCheckBox.push(checkbox);
		this.groupZoneSetting.add(checkbox);

		
		
		for (var iIndex=0;iIndex<dss.staticDataModel.nameCache.length;iIndex++)
			if (dss.staticDataModel.nameCache[iIndex].ZoneID==this.newZone) {
				for (var jIndex=0;jIndex<dss.staticDataModel.nameCache[iIndex].groups.length;jIndex++) {
					var groupObject=dss.staticDataModel.nameCache[iIndex].groups[jIndex];
					var fShouldBeAdded=false;
					if([2,3,4,5,9,10].indexOf(groupObject.group)>=0) {
						if (expertMode)
							fShouldBeAdded=true;
						if (groupObject.connectedDevices!=0)
							fShouldBeAdded=true;
						var oDeviceArray=dss.staticDataModel.getDevicesForZone (this.newZone,groupObject.group);
						for (var kIndex=0;kIndex<oDeviceArray.length;kIndex++) {
							if (oDeviceArray[kIndex].present)
								if (oDeviceArray[kIndex].outputMode!=0)
									fShouldBeAdded=true;
						}
					}
					if (fShouldBeAdded) {
						var checkbox=Ext.create('Ext.form.field.Checkbox',{
							boxLabel:groupObject.name,
							checked:true
						});
						checkbox.groupValue=groupObject.group
						this.groupCheckBox.push(checkbox);
						this.groupZoneSetting.add(checkbox);
					}
						
				}
			}

		this.baseDSID=allValues.baseValues.baseDSID;
		var shouldBeMaintained=[];

		var oldZone=null;
		for (var iIndex=0;iIndex<Ext.data.StoreManager.lookup('thanosStore').getCount();iIndex++) {
			var record=Ext.data.StoreManager.lookup('thanosStore').getAt(iIndex);
			if (record.get('basedSID')==this.baseDSID) 
				if (record.get('internalScreenNumber')==1)
					oldZone=record.get('zoneID');
		}

		
		for (var iIndex=0;iIndex<Ext.data.StoreManager.lookup('thanosStore').getCount();iIndex++) {
			var record=Ext.data.StoreManager.lookup('thanosStore').getAt(iIndex);
			if (record.get('basedSID')==this.baseDSID) 
				if (record.get('dSID')!=-1)
					if (record.get('internalScreenNumber')!=1)
						if (record.get('internalScreenNumber')!=2)
							if (record.get('type')!=0)
								if (((record.get('zoneID')!=this.newZone) && (record.get('zoneID')!=oldZone)) || 
									(record.get('type')==8)) {
									shouldBeMaintained.push(record);
								}
		}
		
		
		for (var iIndex=0;iIndex<shouldBeMaintained.length;iIndex++) {
			//if (this.otherCheckBox.length + this.groupCheckBox.length<8) 
			{
				var group=parseInt('' + shouldBeMaintained[iIndex].get('type'));
				var zone=shouldBeMaintained[iIndex].get('zoneID');
				var checkbox;
				if (group!=8)
					checkbox=Ext.create('Ext.form.field.Checkbox',{
						boxLabel:Ext.String.format2 (_('{group} in {zone}'),{group:dss.staticDataModel.getNameForGroup(zone, group),zone:dss.staticDataModel.getNameForZone(zone)}),
						checked:true
					});
				else {
					var screenNumber=shouldBeMaintained[iIndex].get('internalScreenNumber')
					checkbox=Ext.create('Ext.form.field.Checkbox',{
						boxLabel:Ext.String.format2(_('Generic pushbutton (screen {screennumber})') , {screennumber:screenNumber}),
						checked:true
					})
				};
				checkbox.groupValue=group;
				checkbox.zoneValue=zone;
				checkbox.baseRecord=shouldBeMaintained[iIndex];
				this.otherCheckBox.push(checkbox);
				this.otherSettings.add(checkbox);
				
			}
			
		}
		if (oValue!=null) {
			for (var iIndex=0;iIndex<this.groupCheckBox.length;iIndex++) {
				var fShouldBeChecked=false;
				for (var gIndex=0;gIndex<oValue.newScreens.length;gIndex++)
					if (this.groupCheckBox[iIndex].groupValue==oValue.newScreens[gIndex].type) {
						fShouldBeChecked=true;
					}
				this.groupCheckBox[iIndex].setValue(fShouldBeChecked);
			}
			for (var iIndex=0;iIndex<this.otherCheckBox.length;iIndex++) {
				var fShouldBeChecked=false;
				for (var gIndex=0;gIndex<oValue.maintainedScreens.length;gIndex++)
					if (this.otherCheckBox[iIndex].zoneValue==oValue.maintainedScreens[gIndex].zone)
						if (this.otherCheckBox[iIndex].groupValue==oValue.maintainedScreens[gIndex].type) {
							fShouldBeChecked=true;
						}
				this.otherCheckBox[iIndex].setValue(fShouldBeChecked);
			}
				
		}
	},
	getValue : function() {
		var oObject= {newScreens:[],
				maintainedScreens:[],
				targetStructure:{}};

		var baseIndex=Math.floor(parseInt(this.baseDSID.substring(this.baseDSID.length-3).substring(0,1),16)/8)*8;		
		var parentDSID=this.baseDSID.substring(0,this.baseDSID.length-3);
		for (iIndex=0;iIndex<8;iIndex++) {
			oObject.targetStructure[parentDSID + '' + (baseIndex+iIndex).toString(16) + "00"]={
				basedSID:this.baseDSID,
				dSID:parentDSID + '' + (baseIndex+iIndex).toString(16) + "00",
				type:-1,
				zoneID:5,
				buttontype:5,
				order:(iIndex+1),
				sceneNames:{
					scene1:'',
					scene2:'',
					scene3:'',
					scene4:''
				},
				internalScreenNumber:(iIndex+1)
			};
		}

		for (var iIndex=0;iIndex<this.groupCheckBox.length;iIndex++) {
			if (this.groupCheckBox[iIndex].getValue()) {
				oObject.newScreens.push({
					type:this.groupCheckBox[iIndex].groupValue,
					zone:this.newZone
				})
			}
		}
		for (var iIndex=0;iIndex<this.otherCheckBox.length;iIndex++) {
			if (this.otherCheckBox[iIndex].getValue()) {
				oObject.maintainedScreens.push({
					type:this.otherCheckBox[iIndex].groupValue,
					zone:this.otherCheckBox[iIndex].zoneValue,
					baseRecord:this.otherCheckBox[iIndex].baseRecord
					
				});				
				if (oObject.targetStructure[this.otherCheckBox[iIndex].baseRecord.get('dSID')]!=null) {
					oObject.targetStructure[this.otherCheckBox[iIndex].baseRecord.get('dSID')].type=this.otherCheckBox[iIndex].baseRecord.get('type');
					oObject.targetStructure[this.otherCheckBox[iIndex].baseRecord.get('dSID')].zoneID=this.otherCheckBox[iIndex].baseRecord.get('zoneID');
					oObject.targetStructure[this.otherCheckBox[iIndex].baseRecord.get('dSID')].buttontype=this.otherCheckBox[iIndex].baseRecord.get('buttontype');
					oObject.targetStructure[this.otherCheckBox[iIndex].baseRecord.get('dSID')].sceneNames=this.otherCheckBox[iIndex].baseRecord.get('sceneNames');
					oObject.targetStructure[this.otherCheckBox[iIndex].baseRecord.get('dSID')].order=(iIndex+1)+oObject.newScreens.length;
					oObject.targetStructure[this.otherCheckBox[iIndex].baseRecord.get('dSID')].shouldMaintained=true;
				}
			}
		}		
		var newScreenIndex=0;
		for (iIndex=0;iIndex<8;iIndex++) {
			if (newScreenIndex<oObject.newScreens.length) {
				if (oObject.targetStructure[parentDSID + '' + (baseIndex+iIndex).toString(16) + "00"].type==-1) {
					oObject.targetStructure[parentDSID + '' + (baseIndex+iIndex).toString(16) + "00"].type=oObject.newScreens[newScreenIndex].type;
					oObject.targetStructure[parentDSID + '' + (baseIndex+iIndex).toString(16) + "00"].zoneID=oObject.newScreens[newScreenIndex].zone;
					oObject.targetStructure[parentDSID + '' + (baseIndex+iIndex).toString(16) + "00"].order=newScreenIndex+1;
					oObject.targetStructure[parentDSID + '' + (baseIndex+iIndex).toString(16) + "00"].sceneNames.scene1=dss.staticDataModel.getNameForScene(oObject.newScreens[newScreenIndex].zone,oObject.newScreens[newScreenIndex].type,5);
					oObject.targetStructure[parentDSID + '' + (baseIndex+iIndex).toString(16) + "00"].sceneNames.scene2=dss.staticDataModel.getNameForScene(oObject.newScreens[newScreenIndex].zone,oObject.newScreens[newScreenIndex].type,17);
					oObject.targetStructure[parentDSID + '' + (baseIndex+iIndex).toString(16) + "00"].sceneNames.scene3=dss.staticDataModel.getNameForScene(oObject.newScreens[newScreenIndex].zone,oObject.newScreens[newScreenIndex].type,18);
					oObject.targetStructure[parentDSID + '' + (baseIndex+iIndex).toString(16) + "00"].sceneNames.scene4=dss.staticDataModel.getNameForScene(oObject.newScreens[newScreenIndex].zone,oObject.newScreens[newScreenIndex].type,19);
					oObject.targetStructure[parentDSID + '' + (baseIndex+iIndex).toString(16) + "00"].shouldMaintained=false;
					newScreenIndex++;
				}					
			}
		}
		return oObject;
	}
});